diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/post.php	2013-04-04 10:57:46.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/post.php	2013-07-20 15:20:47.000000000 -0500
***************
*** 203,209 ****
   *
   * @param int $attachment_id Attachment ID
   * @param string $file File path for the attachment
!  * @return bool False on failure, true on success.
   */
  function update_attached_file( $attachment_id, $file ) {
  	if ( !get_post( $attachment_id ) )
--- 203,209 ----
   *
   * @param int $attachment_id Attachment ID
   * @param string $file File path for the attachment
!  * @return bool True on success, false on failure.
   */
  function update_attached_file( $attachment_id, $file ) {
  	if ( !get_post( $attachment_id ) )
***************
*** 360,366 ****
  		$more_text = '';
  	}
  
! 	// Strip leading and trailing whitespace
  	$main = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $main);
  	$extended = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $extended);
  	$more_text = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $more_text);
--- 360,366 ----
  		$more_text = '';
  	}
  
! 	// ` leading and trailing whitespace
  	$main = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $main);
  	$extended = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $extended);
  	$more_text = preg_replace('/^[\s]*(.*)[\s]*$/', '\\1', $more_text);
***************
*** 567,572 ****
--- 567,583 ----
  	 */
  	public $filter;
  
+ 	/**
+ 	 * Private variable used by post formats to cache parsed content.
+ 	 *
+ 	 * @since 3.6.0
+ 	 *
+ 	 * @var array
+ 	 * @access private
+ 	 */
+ 	public $format_content;
+ 
+ 
  	public static function get_instance( $post_id ) {
  		global $wpdb;
  
***************
*** 713,722 ****
   * @since 2.3.0
   * @uses sanitize_post_field() See for possible $context values.
   *
!  * @param string $field Post field name
!  * @param id $post Post ID
!  * @param string $context Optional. How to filter the field. Default is display.
!  * @return bool|string False on failure or returns the value in post field
   */
  function get_post_field( $field, $post, $context = 'display' ) {
  	$post = get_post( $post );
--- 724,733 ----
   * @since 2.3.0
   * @uses sanitize_post_field() See for possible $context values.
   *
!  * @param string $field Post field name.
!  * @param int|object $post Post ID or post object.
!  * @param string $context Optional. How to filter the field. Default is 'display'.
!  * @return string The value of the post field on success, empty string on failure.
   */
  function get_post_field( $field, $post, $context = 'display' ) {
  	$post = get_post( $post );
***************
*** 738,745 ****
   *
   * @since 2.0.0
   *
!  * @param int $ID Optional. Post ID.
!  * @return bool|string False on failure or returns the mime type
   */
  function get_post_mime_type($ID = '') {
  	$post = get_post($ID);
--- 749,756 ----
   *
   * @since 2.0.0
   *
!  * @param int $ID Optional. Post ID. Default is the current post from the loop.
!  * @return string|bool The mime type on success, false on failure.
   */
  function get_post_mime_type($ID = '') {
  	$post = get_post($ID);
***************
*** 751,821 ****
  }
  
  /**
-  * Retrieve the format slug for a post
-  *
-  * @since 3.1.0
-  *
-  * @param int|object $post A post
-  *
-  * @return mixed The format if successful. False if no format is set. WP_Error if errors.
-  */
- function get_post_format( $post = null ) {
- 	$post = get_post($post);
- 
- 	if ( ! post_type_supports( $post->post_type, 'post-formats' ) )
- 		return false;
- 
- 	$_format = get_the_terms( $post->ID, 'post_format' );
- 
- 	if ( empty( $_format ) )
- 		return false;
- 
- 	$format = array_shift( $_format );
- 
- 	return ( str_replace('post-format-', '', $format->slug ) );
- }
- 
- /**
-  * Check if a post has a particular format
-  *
-  * @since 3.1.0
-  * @uses has_term()
-  *
-  * @param string $format The format to check for
-  * @param object|id $post The post to check. If not supplied, defaults to the current post if used in the loop.
-  * @return bool True if the post has the format, false otherwise.
-  */
- function has_post_format( $format, $post = null ) {
- 	return has_term('post-format-' . sanitize_key($format), 'post_format', $post);
- }
- 
- /**
-  * Assign a format to a post
-  *
-  * @since 3.1.0
-  *
-  * @param int|object $post The post for which to assign a format
-  * @param string $format  A format to assign. Use an empty string or array to remove all formats from the post.
-  * @return mixed WP_Error on error. Array of affected term IDs on success.
-  */
- function set_post_format( $post, $format ) {
- 	$post = get_post($post);
- 
- 	if ( empty($post) )
- 		return new WP_Error('invalid_post', __('Invalid post'));
- 
- 	if ( !empty($format) ) {
- 		$format = sanitize_key($format);
- 		if ( 'standard' == $format || !in_array( $format, array_keys( get_post_format_slugs() ) ) )
- 			$format = '';
- 		else
- 			$format = 'post-format-' . $format;
- 	}
- 
- 	return wp_set_post_terms($post->ID, $format, 'post_format');
- }
- 
- /**
   * Retrieve the post status based on the Post ID.
   *
   * If the post ID is of an attachment, then the parent post status will be given
--- 762,767 ----
***************
*** 823,830 ****
   *
   * @since 2.0.0
   *
!  * @param int $ID Post ID
!  * @return string|bool Post status or false on failure.
   */
  function get_post_status($ID = '') {
  	$post = get_post($ID);
--- 769,776 ----
   *
   * @since 2.0.0
   *
!  * @param int $ID Optional. Post ID. Default is the current post from the loop.
!  * @return string|bool Post status on success, false on failure.
   */
  function get_post_status($ID = '') {
  	$post = get_post($ID);
***************
*** 858,864 ****
   *
   * @return array List of post statuses.
   */
! function get_post_statuses( ) {
  	$status = array(
  		'draft'			=> __('Draft'),
  		'pending'		=> __('Pending Review'),
--- 804,810 ----
   *
   * @return array List of post statuses.
   */
! function get_post_statuses() {
  	$status = array(
  		'draft'			=> __('Draft'),
  		'pending'		=> __('Pending Review'),
***************
*** 879,885 ****
   *
   * @return array List of page statuses.
   */
! function get_page_statuses( ) {
  	$status = array(
  		'draft'			=> __('Draft'),
  		'private'		=> __('Private'),
--- 825,831 ----
   *
   * @return array List of page statuses.
   */
! function get_page_statuses() {
  	$status = array(
  		'draft'			=> __('Draft'),
  		'private'		=> __('Private'),
***************
*** 1063,1072 ****
   *
   * @since 2.1.0
   *
!  * @uses $post The Loop current post global
!  *
!  * @param mixed $post Optional. Post object or post ID.
!  * @return bool|string post type or false on failure.
   */
  function get_post_type( $post = null ) {
  	if ( $post = get_post( $post ) )
--- 1009,1016 ----
   *
   * @since 2.1.0
   *
!  * @param int|object $post Optional. Post ID or post object. Default is the current post from the loop.
!  * @return string|bool Post type on success, false on failure.
   */
  function get_post_type( $post = null ) {
  	if ( $post = get_post( $post ) )
***************
*** 1139,1145 ****
   *     * While the default settings of exclude_from_search, publicly_queryable, show_ui, and show_in_nav_menus are
   *       inherited from public, each does not rely on this relationship and controls a very specific intention.
   * - exclude_from_search - Whether to exclude posts with this post type from front end search results.
!  *     * If not set, the the opposite of public's current value is used.
   * - publicly_queryable - Whether queries can be performed on the front end for the post type as part of parse_request().
   *     * ?post_type={post_type_key}
   *     * ?{post_type_key}={single_post_slug}
--- 1083,1089 ----
   *     * While the default settings of exclude_from_search, publicly_queryable, show_ui, and show_in_nav_menus are
   *       inherited from public, each does not rely on this relationship and controls a very specific intention.
   * - exclude_from_search - Whether to exclude posts with this post type from front end search results.
!  *     * If not set, the opposite of public's current value is used.
   * - publicly_queryable - Whether queries can be performed on the front end for the post type as part of parse_request().
   *     * ?post_type={post_type_key}
   *     * ?{post_type_key}={single_post_slug}
***************
*** 1594,1604 ****
  function remove_post_type_support( $post_type, $feature ) {
  	global $_wp_post_type_features;
  
! 	if ( !isset($_wp_post_type_features[$post_type]) )
! 		return;
! 
! 	if ( isset($_wp_post_type_features[$post_type][$feature]) )
! 		unset($_wp_post_type_features[$post_type][$feature]);
  }
  
  /**
--- 1538,1545 ----
  function remove_post_type_support( $post_type, $feature ) {
  	global $_wp_post_type_features;
  
! 	if ( isset( $_wp_post_type_features[$post_type][$feature] ) )
! 		unset( $_wp_post_type_features[$post_type][$feature] );
  }
  
  /**
***************
*** 1630,1646 ****
  function post_type_supports( $post_type, $feature ) {
  	global $_wp_post_type_features;
  
! 	if ( !isset( $_wp_post_type_features[$post_type][$feature] ) )
! 		return false;
! 
! 	// If no args passed then no extra checks need be performed
! 	if ( func_num_args() <= 2 )
! 		return true;
! 
! 	// @todo Allow pluggable arg checking
! 	//$args = array_slice( func_get_args(), 2 );
! 
! 	return true;
  }
  
  /**
--- 1571,1577 ----
  function post_type_supports( $post_type, $feature ) {
  	global $_wp_post_type_features;
  
! 	return ( isset( $_wp_post_type_features[$post_type][$feature] ) );
  }
  
  /**
***************
*** 1742,1748 ****
   * @param string $meta_key Metadata name.
   * @param mixed $meta_value Metadata value.
   * @param bool $unique Optional, default is false. Whether the same key should not be added.
!  * @return bool False for failure. True for success.
   */
  function add_post_meta($post_id, $meta_key, $meta_value, $unique = false) {
  	// make sure meta is added to the post, not a revision
--- 1673,1679 ----
   * @param string $meta_key Metadata name.
   * @param mixed $meta_value Metadata value.
   * @param bool $unique Optional, default is false. Whether the same key should not be added.
!  * @return int|bool Meta ID on success, false on failure.
   */
  function add_post_meta($post_id, $meta_key, $meta_value, $unique = false) {
  	// make sure meta is added to the post, not a revision
***************
*** 1766,1772 ****
   * @param int $post_id post ID
   * @param string $meta_key Metadata name.
   * @param mixed $meta_value Optional. Metadata value.
!  * @return bool False for failure. True for success.
   */
  function delete_post_meta($post_id, $meta_key, $meta_value = '') {
  	// make sure meta is added to the post, not a revision
--- 1697,1703 ----
   * @param int $post_id post ID
   * @param string $meta_key Metadata name.
   * @param mixed $meta_value Optional. Metadata value.
!  * @return bool True on success, false on failure.
   */
  function delete_post_meta($post_id, $meta_key, $meta_value = '') {
  	// make sure meta is added to the post, not a revision
***************
*** 1809,1815 ****
   * @param string $meta_key Metadata key.
   * @param mixed $meta_value Metadata value.
   * @param mixed $prev_value Optional. Previous value to check before removing.
!  * @return bool False on failure, true if success.
   */
  function update_post_meta($post_id, $meta_key, $meta_value, $prev_value = '') {
  	// make sure meta is added to the post, not a revision
--- 1740,1746 ----
   * @param string $meta_key Metadata key.
   * @param mixed $meta_value Metadata value.
   * @param mixed $prev_value Optional. Previous value to check before removing.
!  * @return bool True on success, false on failure.
   */
  function update_post_meta($post_id, $meta_key, $meta_value, $prev_value = '') {
  	// make sure meta is added to the post, not a revision
***************
*** 2170,2176 ****
  	$and = wp_post_mime_type_where( $mime_type );
  	$count = $wpdb->get_results( "SELECT post_mime_type, COUNT( * ) AS num_posts FROM $wpdb->posts WHERE post_type = 'attachment' AND post_status != 'trash' $and GROUP BY post_mime_type", ARRAY_A );
  
! 	$stats = array( );
  	foreach( (array) $count as $row ) {
  		$stats[$row['post_mime_type']] = $row['num_posts'];
  	}
--- 2101,2107 ----
  	$and = wp_post_mime_type_where( $mime_type );
  	$count = $wpdb->get_results( "SELECT post_mime_type, COUNT( * ) AS num_posts FROM $wpdb->posts WHERE post_type = 'attachment' AND post_status != 'trash' $and GROUP BY post_mime_type", ARRAY_A );
  
! 	$stats = array();
  	foreach( (array) $count as $row ) {
  		$stats[$row['post_mime_type']] = $row['num_posts'];
  	}
***************
*** 2458,2464 ****
   * @uses do_action() on 'trash_post_comments' before trashing
   * @uses do_action() on 'trashed_post_comments' after trashing
   *
!  * @param int $post Post ID or object.
   * @return mixed False on failure
   */
  function wp_trash_post_comments($post = null) {
--- 2389,2395 ----
   * @uses do_action() on 'trash_post_comments' before trashing
   * @uses do_action() on 'trashed_post_comments' after trashing
   *
!  * @param int|object $post Post ID or object.
   * @return mixed False on failure
   */
  function wp_trash_post_comments($post = null) {
***************
*** 2499,2505 ****
   * @uses do_action() on 'untrash_post_comments' before trashing
   * @uses do_action() on 'untrashed_post_comments' after trashing
   *
!  * @param int $post Post ID or object.
   * @return mixed False on failure
   */
  function wp_untrash_post_comments($post = null) {
--- 2430,2436 ----
   * @uses do_action() on 'untrash_post_comments' before trashing
   * @uses do_action() on 'untrashed_post_comments' after trashing
   *
!  * @param int|object $post Post ID or object.
   * @return mixed False on failure
   */
  function wp_untrash_post_comments($post = null) {
***************
*** 2662,2668 ****
   *
   * If the $postarr parameter has 'ID' set to a value, then post will be updated.
   *
!  * You can set the post date manually, but setting the values for 'post_date'
   * and 'post_date_gmt' keys. You can close the comments or open the comments by
   * setting the value for 'comment_status' key.
   *
--- 2593,2599 ----
   *
   * If the $postarr parameter has 'ID' set to a value, then post will be updated.
   *
!  * You can set the post date manually, by setting the values for 'post_date'
   * and 'post_date_gmt' keys. You can close the comments or open the comments by
   * setting the value for 'comment_status' key.
   *
***************
*** 2713,2721 ****
  	extract($postarr, EXTR_SKIP);
  
  	// Are we updating or creating?
  	$update = false;
! 	if ( !empty($ID) ) {
  		$update = true;
  		$previous_status = get_post_field('post_status', $ID);
  	} else {
  		$previous_status = 'new';
--- 2644,2664 ----
  	extract($postarr, EXTR_SKIP);
  
  	// Are we updating or creating?
+ 	$post_ID = 0;
  	$update = false;
! 	if ( ! empty( $ID ) ) {
  		$update = true;
+ 
+ 		// Get the post ID and GUID
+ 		$post_ID = $ID;
+ 		$post_before = get_post( $post_ID );
+ 		if ( is_null( $post_before ) ) {
+ 			if ( $wp_error )
+ 				return new WP_Error( 'invalid_post', __( 'Invalid post ID.' ) );
+ 			return 0;
+ 		}
+ 
+ 		$guid = get_post_field( 'guid', $post_ID );
  		$previous_status = get_post_field('post_status', $ID);
  	} else {
  		$previous_status = 'new';
***************
*** 2751,2765 ****
  	if ( empty($post_author) )
  		$post_author = $user_ID;
  
- 	$post_ID = 0;
- 
- 	// Get the post ID and GUID
- 	if ( $update ) {
- 		$post_ID = (int) $ID;
- 		$guid = get_post_field( 'guid', $post_ID );
- 		$post_before = get_post($post_ID);
- 	}
- 
  	// Don't allow contributors to set the post slug for pending review posts
  	if ( 'pending' == $post_status && !current_user_can( 'publish_posts' ) )
  		$post_name = '';
--- 2695,2700 ----
***************
*** 2859,2869 ****
  	// expected_slashed (everything!)
  	$data = compact( array( 'post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_content_filtered', 'post_title', 'post_excerpt', 'post_status', 'post_type', 'comment_status', 'ping_status', 'post_password', 'post_name', 'to_ping', 'pinged', 'post_modified', 'post_modified_gmt', 'post_parent', 'menu_order', 'guid' ) );
  	$data = apply_filters('wp_insert_post_data', $data, $postarr);
! 	$data = stripslashes_deep( $data );
  	$where = array( 'ID' => $post_ID );
  
  	if ( $update ) {
! 		do_action( 'pre_post_update', $post_ID );
  		if ( false === $wpdb->update( $wpdb->posts, $data, $where ) ) {
  			if ( $wp_error )
  				return new WP_Error('db_update_error', __('Could not update post in the database'), $wpdb->last_error);
--- 2794,2804 ----
  	// expected_slashed (everything!)
  	$data = compact( array( 'post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_content_filtered', 'post_title', 'post_excerpt', 'post_status', 'post_type', 'comment_status', 'ping_status', 'post_password', 'post_name', 'to_ping', 'pinged', 'post_modified', 'post_modified_gmt', 'post_parent', 'menu_order', 'guid' ) );
  	$data = apply_filters('wp_insert_post_data', $data, $postarr);
! 	$data = wp_unslash( $data );
  	$where = array( 'ID' => $post_ID );
  
  	if ( $update ) {
! 		do_action( 'pre_post_update', $post_ID, $data );
  		if ( false === $wpdb->update( $wpdb->posts, $data, $where ) ) {
  			if ( $wp_error )
  				return new WP_Error('db_update_error', __('Could not update post in the database'), $wpdb->last_error);
***************
*** 2872,2878 ****
  		}
  	} else {
  		if ( isset($post_mime_type) )
! 			$data['post_mime_type'] = stripslashes( $post_mime_type ); // This isn't in the update
  		// If there is a suggested ID, use it if not already present
  		if ( !empty($import_id) ) {
  			$import_id = (int) $import_id;
--- 2807,2813 ----
  		}
  	} else {
  		if ( isset($post_mime_type) )
! 			$data['post_mime_type'] = wp_unslash( $post_mime_type ); // This isn't in the update
  		// If there is a suggested ID, use it if not already present
  		if ( !empty($import_id) ) {
  			$import_id = (int) $import_id;
***************
*** 2966,2979 ****
  	if ( is_object($postarr) ) {
  		// non-escaped post was passed
  		$postarr = get_object_vars($postarr);
! 		$postarr = add_magic_quotes($postarr);
  	}
  
  	// First, get all of the original fields
  	$post = get_post($postarr['ID'], ARRAY_A);
  
  	// Escape data pulled from DB.
! 	$post = add_magic_quotes($post);
  
  	// Passed post category list overwrites existing category list if not empty.
  	if ( isset($postarr['post_category']) && is_array($postarr['post_category'])
--- 2901,2920 ----
  	if ( is_object($postarr) ) {
  		// non-escaped post was passed
  		$postarr = get_object_vars($postarr);
! 		$postarr = wp_slash($postarr);
  	}
  
  	// First, get all of the original fields
  	$post = get_post($postarr['ID'], ARRAY_A);
  
+ 	if ( is_null( $post ) ) {
+ 		if ( $wp_error )
+ 			return new WP_Error( 'invalid_post', __( 'Invalid post ID.' ) );
+ 		return 0;
+ 	}
+ 
  	// Escape data pulled from DB.
! 	$post = wp_slash($post);
  
  	// Passed post category list overwrites existing category list if not empty.
  	if ( isset($postarr['post_category']) && is_array($postarr['post_category'])
***************
*** 3010,3016 ****
   * @uses $wpdb
   * @uses do_action() Calls 'edit_post', 'save_post', and 'wp_insert_post' on post_id and post data.
   *
!  * @param mixed $post Post ID or object.
   */
  function wp_publish_post( $post ) {
  	global $wpdb;
--- 2951,2957 ----
   * @uses $wpdb
   * @uses do_action() Calls 'edit_post', 'save_post', and 'wp_insert_post' on post_id and post data.
   *
!  * @param int|object $post Post ID or object.
   */
  function wp_publish_post( $post ) {
  	global $wpdb;
***************
*** 3081,3087 ****
   * @return string unique slug for the post, based on $post_name (with a -1, -2, etc. suffix)
   */
  function wp_unique_post_slug( $slug, $post_ID, $post_status, $post_type, $post_parent ) {
! 	if ( in_array( $post_status, array( 'draft', 'pending', 'auto-draft' ) ) )
  		return $slug;
  
  	global $wpdb, $wp_rewrite;
--- 3022,3028 ----
   * @return string unique slug for the post, based on $post_name (with a -1, -2, etc. suffix)
   */
  function wp_unique_post_slug( $slug, $post_ID, $post_status, $post_type, $post_parent ) {
! 	if ( in_array( $post_status, array( 'draft', 'pending', 'auto-draft' ) ) || ( 'inherit' == $post_status && 'revision' == $post_type ) )
  		return $slug;
  
  	global $wpdb, $wp_rewrite;
***************
*** 3101,3108 ****
  		if ( $post_name_check || in_array( $slug, $feeds ) || apply_filters( 'wp_unique_post_slug_is_bad_attachment_slug', false, $slug ) ) {
  			$suffix = 2;
  			do {
! 				$alt_post_name = substr ($slug, 0, 200 - ( strlen( $suffix ) + 1 ) ) . "-$suffix";
! 				$post_name_check = $wpdb->get_var( $wpdb->prepare($check_sql, $alt_post_name, $post_ID ) );
  				$suffix++;
  			} while ( $post_name_check );
  			$slug = $alt_post_name;
--- 3042,3049 ----
  		if ( $post_name_check || in_array( $slug, $feeds ) || apply_filters( 'wp_unique_post_slug_is_bad_attachment_slug', false, $slug ) ) {
  			$suffix = 2;
  			do {
! 				$alt_post_name = _truncate_post_slug( $slug, 200 - ( strlen( $suffix ) + 1 ) ) . "-$suffix";
! 				$post_name_check = $wpdb->get_var( $wpdb->prepare( $check_sql, $alt_post_name, $post_ID ) );
  				$suffix++;
  			} while ( $post_name_check );
  			$slug = $alt_post_name;
***************
*** 3118,3124 ****
  		if ( $post_name_check || in_array( $slug, $feeds ) || preg_match( "@^($wp_rewrite->pagination_base)?\d+$@", $slug )  || apply_filters( 'wp_unique_post_slug_is_bad_hierarchical_slug', false, $slug, $post_type, $post_parent ) ) {
  			$suffix = 2;
  			do {
! 				$alt_post_name = substr( $slug, 0, 200 - ( strlen( $suffix ) + 1 ) ) . "-$suffix";
  				$post_name_check = $wpdb->get_var( $wpdb->prepare( $check_sql, $alt_post_name, $post_ID, $post_parent ) );
  				$suffix++;
  			} while ( $post_name_check );
--- 3059,3065 ----
  		if ( $post_name_check || in_array( $slug, $feeds ) || preg_match( "@^($wp_rewrite->pagination_base)?\d+$@", $slug )  || apply_filters( 'wp_unique_post_slug_is_bad_hierarchical_slug', false, $slug, $post_type, $post_parent ) ) {
  			$suffix = 2;
  			do {
! 				$alt_post_name = _truncate_post_slug( $slug, 200 - ( strlen( $suffix ) + 1 ) ) . "-$suffix";
  				$post_name_check = $wpdb->get_var( $wpdb->prepare( $check_sql, $alt_post_name, $post_ID, $post_parent ) );
  				$suffix++;
  			} while ( $post_name_check );
***************
*** 3132,3138 ****
  		if ( $post_name_check || in_array( $slug, $feeds ) || apply_filters( 'wp_unique_post_slug_is_bad_flat_slug', false, $slug, $post_type ) ) {
  			$suffix = 2;
  			do {
! 				$alt_post_name = substr( $slug, 0, 200 - ( strlen( $suffix ) + 1 ) ) . "-$suffix";
  				$post_name_check = $wpdb->get_var( $wpdb->prepare( $check_sql, $alt_post_name, $post_type, $post_ID ) );
  				$suffix++;
  			} while ( $post_name_check );
--- 3073,3079 ----
  		if ( $post_name_check || in_array( $slug, $feeds ) || apply_filters( 'wp_unique_post_slug_is_bad_flat_slug', false, $slug, $post_type ) ) {
  			$suffix = 2;
  			do {
! 				$alt_post_name = _truncate_post_slug( $slug, 200 - ( strlen( $suffix ) + 1 ) ) . "-$suffix";
  				$post_name_check = $wpdb->get_var( $wpdb->prepare( $check_sql, $alt_post_name, $post_type, $post_ID ) );
  				$suffix++;
  			} while ( $post_name_check );
***************
*** 3144,3149 ****
--- 3085,3113 ----
  }
  
  /**
+  * Truncates a post slug.
+  *
+  * @since 3.6.0
+  * @access private
+  * @uses utf8_uri_encode() Makes sure UTF-8 characters are properly cut and encoded.
+  *
+  * @param string $slug The slug to truncate.
+  * @param int $length Max length of the slug.
+  * @return string The truncated slug.
+  */
+ function _truncate_post_slug( $slug, $length = 200 ) {
+ 	if ( strlen( $slug ) > $length ) {
+ 		$decoded_slug = urldecode( $slug );
+ 		if ( $decoded_slug === $slug )
+ 			$slug = substr( $slug, 0, $length );
+ 		else
+ 			$slug = utf8_uri_encode( $decoded_slug, $length );
+ 	}
+ 
+ 	return rtrim( $slug, '-' );
+ }
+ 
+ /**
   * Adds tags to a post.
   *
   * @uses wp_set_post_tags() Same first two parameters, but the last parameter is always set to true.
***************
*** 3296,3302 ****
  	$new = implode("\n", $pung);
  	$new = apply_filters('add_ping', $new);
  	// expected_slashed ($new)
! 	$new = stripslashes($new);
  	return $wpdb->update( $wpdb->posts, array( 'pinged' => $new ), array( 'ID' => $post_id ) );
  }
  
--- 3260,3266 ----
  	$new = implode("\n", $pung);
  	$new = apply_filters('add_ping', $new);
  	// expected_slashed ($new)
! 	$new = wp_unslash($new);
  	return $wpdb->update( $wpdb->posts, array( 'pinged' => $new ), array( 'ID' => $post_id ) );
  }
  
***************
*** 3383,3395 ****
  		$excerpt = strip_tags($post_excerpt ? $post_excerpt : $post_content);
  
  		if (strlen($excerpt) > 255) {
! 			$excerpt = substr($excerpt,0,252) . '...';
  		}
  
  		$trackback_urls = explode(',', $tb_list);
  		foreach( (array) $trackback_urls as $tb_url) {
  			$tb_url = trim($tb_url);
! 			trackback($tb_url, stripslashes($post_title), $excerpt, $post_id);
  		}
  	}
  }
--- 3347,3359 ----
  		$excerpt = strip_tags($post_excerpt ? $post_excerpt : $post_content);
  
  		if (strlen($excerpt) > 255) {
! 			$excerpt = substr($excerpt,0,252) . '&hellip;';
  		}
  
  		$trackback_urls = explode(',', $tb_list);
  		foreach( (array) $trackback_urls as $tb_url) {
  			$tb_url = trim($tb_url);
! 			trackback($tb_url, wp_unslash($post_title), $excerpt, $post_id);
  		}
  	}
  }
***************
*** 3453,3464 ****
  	$page_path = str_replace('%2F', '/', $page_path);
  	$page_path = str_replace('%20', ' ', $page_path);
  	$parts = explode( '/', trim( $page_path, '/' ) );
! 	$parts = array_map( 'esc_sql', $parts );
  	$parts = array_map( 'sanitize_title_for_query', $parts );
  
  	$in_string = "'". implode( "','", $parts ) . "'";
! 	$post_type_sql = $post_type;
! 	$wpdb->escape_by_ref( $post_type_sql );
  	$pages = $wpdb->get_results( "SELECT ID, post_name, post_parent, post_type FROM $wpdb->posts WHERE post_name IN ($in_string) AND (post_type = '$post_type_sql' OR post_type = 'attachment')", OBJECT_K );
  
  	$revparts = array_reverse( $parts );
--- 3417,3427 ----
  	$page_path = str_replace('%2F', '/', $page_path);
  	$page_path = str_replace('%20', ' ', $page_path);
  	$parts = explode( '/', trim( $page_path, '/' ) );
! 	$parts = esc_sql( $parts );
  	$parts = array_map( 'sanitize_title_for_query', $parts );
  
  	$in_string = "'". implode( "','", $parts ) . "'";
! 	$post_type_sql = esc_sql( $post_type );
  	$pages = $wpdb->get_results( "SELECT ID, post_name, post_parent, post_type FROM $wpdb->posts WHERE post_name IN ($in_string) AND (post_type = '$post_type_sql' OR post_type = 'attachment')", OBJECT_K );
  
  	$revparts = array_reverse( $parts );
***************
*** 3646,3660 ****
  	if ( array_diff( $post_status, get_post_stati() ) )
  		return $pages;
  
! 	$cache = array();
  	$key = md5( serialize( compact(array_keys($defaults)) ) );
! 	if ( $cache = wp_cache_get( 'get_pages', 'posts' ) ) {
! 		if ( is_array($cache) && isset( $cache[ $key ] ) && is_array( $cache[ $key ] ) ) {
! 			// Convert to WP_Post instances
! 			$pages = array_map( 'get_post', $cache[ $key ] );
! 			$pages = apply_filters( 'get_pages', $pages, $r );
! 			return $pages;
! 		}
  	}
  
  	if ( !is_array($cache) )
--- 3609,3628 ----
  	if ( array_diff( $post_status, get_post_stati() ) )
  		return $pages;
  
! 	// $args can be whatever, only use the args defined in defaults to compute the key
  	$key = md5( serialize( compact(array_keys($defaults)) ) );
! 	$last_changed = wp_cache_get( 'last_changed', 'posts' );
! 	if ( ! $last_changed ) {
! 		$last_changed = microtime();
! 		wp_cache_set( 'last_changed', $last_changed, 'posts' );
! 	}
! 
! 	$cache_key = "get_pages:$key:$last_changed";
! 	if ( $cache = wp_cache_get( $cache_key, 'posts' ) ) {
! 		// Convert to WP_Post instances
! 		$pages = array_map( 'get_post', $cache );
! 		$pages = apply_filters('get_pages', $pages, $r);
! 		return $pages;
  	}
  
  	if ( !is_array($cache) )
***************
*** 3724,3738 ****
  
  	$join = '';
  	$where = "$exclusions $inclusions ";
! 	if ( ! empty( $meta_key ) || ! empty( $meta_value ) ) {
  		$join = " LEFT JOIN $wpdb->postmeta ON ( $wpdb->posts.ID = $wpdb->postmeta.post_id )";
  
  		// meta_key and meta_value might be slashed
! 		$meta_key = stripslashes($meta_key);
! 		$meta_value = stripslashes($meta_value);
! 		if ( ! empty( $meta_key ) )
  			$where .= $wpdb->prepare(" AND $wpdb->postmeta.meta_key = %s", $meta_key);
! 		if ( ! empty( $meta_value ) )
  			$where .= $wpdb->prepare(" AND $wpdb->postmeta.meta_value = %s", $meta_value);
  
  	}
--- 3692,3706 ----
  
  	$join = '';
  	$where = "$exclusions $inclusions ";
! 	if ( '' !== $meta_key || '' !== $meta_value ) {
  		$join = " LEFT JOIN $wpdb->postmeta ON ( $wpdb->posts.ID = $wpdb->postmeta.post_id )";
  
  		// meta_key and meta_value might be slashed
! 		$meta_key = wp_unslash($meta_key);
! 		$meta_value = wp_unslash($meta_value);
! 		if ( '' !== $meta_key )
  			$where .= $wpdb->prepare(" AND $wpdb->postmeta.meta_key = %s", $meta_key);
! 		if ( '' !== $meta_value )
  			$where .= $wpdb->prepare(" AND $wpdb->postmeta.meta_value = %s", $meta_value);
  
  	}
***************
*** 3824,3831 ****
  		}
  	}
  
! 	$cache[ $key ] = $pages;
! 	wp_cache_set( 'get_pages', $cache, 'posts' );
  
  	// Convert to WP_Post instances
  	$pages = array_map( 'get_post', $pages );
--- 3792,3802 ----
  		}
  	}
  
! 	$page_structure = array();
! 	foreach ( $pages as $page )
! 		$page_structure[] = $page->ID;
! 
! 	wp_cache_set( $cache_key, $page_structure, 'posts' );
  
  	// Convert to WP_Post instances
  	$pages = array_map( 'get_post', $pages );
***************
*** 3905,3911 ****
  	global $wpdb, $user_ID;
  
  	$defaults = array('post_status' => 'inherit', 'post_type' => 'post', 'post_author' => $user_ID,
! 		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0,
  		'menu_order' => 0, 'to_ping' =>  '', 'pinged' => '', 'post_password' => '',
  		'guid' => '', 'post_content_filtered' => '', 'post_excerpt' => '', 'import_id' => 0, 'context' => '');
  
--- 3876,3882 ----
  	global $wpdb, $user_ID;
  
  	$defaults = array('post_status' => 'inherit', 'post_type' => 'post', 'post_author' => $user_ID,
! 		'ping_status' => get_option('default_ping_status'), 'post_parent' => 0, 'post_title' => '',
  		'menu_order' => 0, 'to_ping' =>  '', 'pinged' => '', 'post_password' => '',
  		'guid' => '', 'post_content_filtered' => '', 'post_excerpt' => '', 'import_id' => 0, 'context' => '');
  
